# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

# Defining variables
bin_name_string = "klavaro-%s-win-setup.exe"
app_uninstallkey = "{42B9496F-F6CC-4E29-959A-18D9F1B0FA6A}_is1"
app_name = "Klavaro"
app_dir = makepath(programfiles32, app_name)
app_bin = makepath(app_dir, "bin")
app_path = makepath(app_bin, "klavaro.exe")
ico = "klavaro.ico"
app_ico = makepath(app_dir, ico)


def install():
    # Initializing variables
    package_version = control.version.split("-", 1)[0]
    bin_name = glob.glob("*%s" % bin_name_string.split("%s")[-1])[0]

    for uninstall in installed_softwares("klavaro"):
        print("Uninstall %s" % uninstall["name"])
        cmd = uninstall_cmd(uninstall["key"])
        run(cmd)
    # Installing the package
    print("Installing: %s" % bin_name)
    install_exe_if_needed(bin_name, silentflags="/VERYSILENT /SUPPRESSMSGBOXES /NORESTART", key=app_uninstallkey, min_version=package_version)

    # Avoiding the usage by WAPT of the app built-in Uninstallstring
    uninstallkey.remove(app_uninstallkey)

    # Compatibility mode on Windows 10
    if windows_version() >= WindowsVersions.Windows10:
        registry_set(
            HKEY_LOCAL_MACHINE,
            r"SOFTWARE\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers",
            app_path,
            r"~ WIN7RTM FaultTolerantHeap",
            type=REG_SZ,
        )

    # Adding proper icon
    filecopyto(ico, app_ico)
    remove_desktop_shortcut(app_name)
    remove_programs_menu_shortcut(app_name)
    remove_programs_menu_folder(app_name)
    # create_desktop_shortcut(app_name, app_path,wDir=app_bin, icon=app_ico)
    create_programs_menu_shortcut(app_name, app_path, wDir=app_bin, icon=app_ico)


def uninstall():
    # Initializing variables
    app_kill = control.impacted_process.split(",")
    count = 0

    # Uninstalling the package
    killalltasks(app_kill)
    cmd = uninstall_cmd(app_uninstallkey)
    run(cmd, accept_returncodes=[0, 1, 3010])
    registry_delete(HKEY_LOCAL_MACHINE, r"SOFTWARE\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers", app_path)

    wait_uninstallkey_absent(app_uninstallkey)

    remove_programs_menu_shortcut(app_name)

    # Removing remaining dir
    if isdir(app_dir):
        remove_tree(app_dir)